/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import javax.swing.*;

/**
 * classe de couplage du module SOFC amont
 * 
 * @author Renaud GICQUEL
 */
public class SOFCCH4MixInlet extends ExtMixer 
{
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField E_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField b_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Jd_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField delta_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField tauJd_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JTextField Qex_value = new javax.swing.JTextField();
	javax.swing.JTextField E1_value = new javax.swing.JTextField();
	javax.swing.JTextField E2_value = new javax.swing.JTextField();
    
    double TamontAir, PamontAir, TamontFuel, PamontFuel;

    String linkProcess,inletFuelProcess,inletAirProcess;
    String linkPoint,inletFuelPoint,inletAirPoint;
    
    double[]inletAirFractmol;
    String[]inletAirComp;
    double[]inletFuelFractmol;
    String[]inletFuelComp;
    
    SOFCCH4MixOutlet outletSOFC;//module SOFC aval
    String outletSOFCName="";
    
    Vector inputFuelComp,inputAirComp;
    double airFlow,airM,fuelFlow,fuelM,Htot;
    double fractO2,fractH2O,fractCO,fractCO2,fractH2;
    
    public SOFCCH4MixInlet (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JPanel1.setBounds(0,0,600,150);
		JLabel1.setText("b parameter");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(b_value);
		b_value.setBounds(164,0,124,20);
		b_value.setText("0.63");
		JLabel2.setText("E parameter");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,24,164,20);
		JPanel1.add(E_value);
		E_value.setBounds(164,24,124,20);
		E_value.setText("0.94");
		JLabel3.setText("Jd parameter");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
		JPanel1.add(Jd_value);
		Jd_value.setBounds(164,48,124,20);
		Jd_value.setText("400");
		JLabel4.setText("delta parameter");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
		JPanel1.add(delta_value);
		delta_value.setBounds(164,72,124,20);
		delta_value.setText("0.0002");
		JLabel5.setText("tau/Jd parameter");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,96,164,20);
		JPanel1.add(tauJd_value);
		tauJd_value.setBounds(164,96,124,20);
		tauJd_value.setText("1.2");
		type=getType();
		thermoCouplerTypes=new String[0];
		JLabel11.setText("E2");
		JPanel1.add(JLabel11);
		JLabel11.setBounds(400,48,100,20);
		JPanel1.add(E2_value);
		E2_value.setBounds(500,48,124,20);
		E2_value.setText("-0.063");
		JLabel10.setText("E1");
		JPanel1.add(JLabel10);
		JLabel10.setBounds(400,24,100,20);
		JPanel1.add(E1_value);
		E1_value.setBounds(500,24,124,20);
		E1_value.setText("-0.176");
		JLabel9.setBounds(400,72,300,20);
		JLabel9.setText("voltage");
	//	JPanel1.add(JLabel9);
		JLabel12.setText("Qcooling fract.");
		JPanel1.add(JLabel12);
		JLabel12.setBounds(400,0,100,20);
		JPanel1.add(Qex_value);
		Qex_value.setBounds(500,0,124,20);
		Qex_value.setText("0.33");
    }
    
    public void init(){
	    getMixerStructure();
        checkConsistency();
		setupOutletSOFC();
    }
    
    public String getType(){
        return "SOFC CH4 Mix inlet";
    }
    
	public void calculateProcess(){//on vrifie toujours la cohrence
	    getMixerStructure();
        checkConsistency();
	}
    
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        inletFuelProcess="";
        inletAirProcess="";
        Htot=0;
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(me, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String aval=(String)vBranch[j].elementAt(2);//gets the downstream point name
	            getPointProperties(aval);//direct parsing of point property vector
	            lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
                getSubstProperties(nomCorps);
                if(typeSubst==4){//le corps d'entre est un gaz compos
                    Vector vComp=lecorps.getGasComposition();
                    System.out.println(" nbElements "+vComp.elementAt(0));

	                if((Util.contains(vComp,"N2"))&&(Util.contains(vComp,"O2"))){
	                    inletAirProcess=nomBranche[j];
	                    inletAirPoint=aval;
	                }
	                else if((Util.contains(vComp,"CH4 ` methane"))||(Util.contains(vComp,"CH4 ` mthane"))){
	                    inletFuelProcess=nomBranche[j];
	                    inletFuelPoint=aval;
	                }
                }
	            else{//le corps d'entre n'est pas un gaz
	                String msg = "Error: the inlet substance is not a gas";
	                JOptionPane.showMessageDialog(me, msg);  
	            }
	        }
	        if((inletAirProcess.equals(""))||(inletFuelProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(me, msg);  
	            isBuilt=false;
	        }
        }
        //initialisations relatives  l'air
        args=new String[2];
        args[0]="process";
        args[1]=inletAirProcess;
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        airFlow=f.doubleValue();//dbit du gaz  traiter
        String aval=(String)vProp.elementAt(2);
        getPointProperties(aval);
        TamontAir=Tpoint;//temprature d'entre de l'air
        PamontAir=Ppoint;//pression d'entre de l'air
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        inputAirComp=lecorps.getGasComposition();//composition du gaz  traiter
        fractO2=Util.molarComp(inputAirComp,"O2");//fraction molaire de O2
        airM=Msubst;//masse molaire du gaz  traiter
        Htot=Hsubst*airFlow;

        //chargement du tableau des fractions molaires du gaz  traiter
        Integer i=(Integer)inputAirComp.elementAt(0);
	    int nComp=i.intValue(); 
        inletAirComp= new String[nComp];
        Double[]fracMol= new Double[nComp];
        inletAirFractmol= new double[nComp];
	    inletAirComp=(String[])inputAirComp.elementAt(1);
	    fracMol=(Double[])inputAirComp.elementAt(2);
        for(int j=0;j<nComp;j++){
            inletAirFractmol[j]= fracMol[j].doubleValue();
        }
        
        //initialisations relatives au gaz inletFuel
        args=new String[2];
        args[0]="process";
        args[1]=inletFuelProcess;
        vProp=proj.getProperties(args);
        f=(Double)vProp.elementAt(3);
        fuelFlow=f.doubleValue();//dbit du gaz inletFuel
        aval=(String)vProp.elementAt(2);
        getPointProperties(aval);
        TamontFuel=Tpoint;//temprature d'entre de l'air
        PamontFuel=Ppoint;//pression d'entre de l'air
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        inputFuelComp=lecorps.getGasComposition();//composition du gaz inletFuel
        fractH2O=Util.molarComp(inputFuelComp,"H2O");//fraction molaire de H2O
        fractH2=Util.molarComp(inputFuelComp,"H2");//fraction molaire de H2
        fractCO=Util.molarComp(inputFuelComp,"CO");//fraction molaire de CO
        fractCO2=Util.molarComp(inputFuelComp,"CO2");//fraction molaire de CO2
        
        fuelM=Msubst;//masse molaire du gaz  traiter
        Htot=Htot+fuelFlow*Hsubst;
            System.out.println("Htot : "+Htot);
        
        //chargement du tableau des fractions molaires du gaz  traiter
        i=(Integer)inputFuelComp.elementAt(0);
	    nComp=i.intValue(); 
        inletFuelComp= new String[nComp];
        fracMol= new Double[nComp];
        inletFuelFractmol= new double[nComp];
	    inletFuelComp=(String[])inputFuelComp.elementAt(1);
	    fracMol=(Double[])inputFuelComp.elementAt(2);
        for(int j=0;j<nComp;j++){
            inletFuelFractmol[j]= fracMol[j].doubleValue();
        }
        
        //initialisations relatives  la transfo-point de liaison
        linkProcess=mainProcess;
	    args[0]="process";
	    args[1]=linkProcess;
	    Vector vPropMain=proj.getProperties(args);
	    aval=(String)vPropMain.elementAt(2);
	    getPointProperties(aval);
	    linkPoint=aval;
    }
    
	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "E_value");
	    if(valeur!=null)E_value.setText(valeur);
	    valeur=Util.extr_value(ligne_data, "E1_value");
	    if(valeur!=null)E1_value.setText(valeur);
	    valeur=Util.extr_value(ligne_data, "E2_value");
	    if(valeur!=null)E2_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "b_value");
        if(valeur!=null)b_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "Qex_value");
        if(valeur!=null)Qex_value.setText(valeur);
		valeur=Util.extr_value(ligne_data, "tauJd_value");
	    if(valeur!=null)tauJd_value.setText(valeur);
		valeur=Util.extr_value(ligne_data, "Jd_value");
	    if(valeur!=null)Jd_value.setText(valeur);
		valeur=Util.extr_value(ligne_data, "delta_value");
	    if(valeur!=null)delta_value.setText(valeur);
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"E_value="+E_value.getText()+tab
	    +"E1_value="+E1_value.getText()+tab
	    +"E2_value="+E2_value.getText()+tab
	    +"b_value="+b_value.getText()+tab
	    +"Qex_value="+Qex_value.getText()+tab
	    +"Jd_value="+Jd_value.getText()+tab
	    +"tauJd_value="+tauJd_value.getText()+tab
	    +"Jd_value="+Jd_value.getText()+tab
	    +"delta_value="+delta_value.getText()+tab
	    ;
        return h;
    }
    
    
    void setupOutletSOFC(){
        Vector vExt=proj.getExternalClassInstances();
        for(int i=0;i<vExt.size();i++){
            Object[] obj=new Object[6];
	        obj=(Object[])vExt.elementAt(i);
	        String type=(String)obj[0];
	        if(type.equals("node")){
	            String main=(String)obj[4];
	            String nodeType=(String)obj[3];
	            if((main.equals(linkProcess))&&((nodeType.equals("SOFC CH4 Mix outlet")))){
	                outletSOFC=(SOFCCH4MixOutlet)obj[1];
	                outletSOFCName=(String)obj[2];
       //             System.out.println("outletSOFC : "+outletSOFC+"  turbineFuelProcess : "+outletSOFC.turbineFuelProcess);
	            }
	        }
        }
    }


}